;*****************************************************
; Copie background vers cran virtuel
;*****************************************************

; Efface l'cran virtuel, 4 niveaux de gris

copy_bck_to_vmem		MACRO
	move.l			save_add1,a0				; Ecrans
	move.l			save_add2,a1
	lea			2(a0),a0
	lea			2(a1),a1
	move.l			scrolling,d0
	tst.b			d0
	bne			\loop

	move.w		#127,d0
\startcopyscr2
	move.l			#0,(a0)+
	move.l			#0,(a1)+
	move.l			#0,(a0)+
	move.l			#0,(a1)+
	move.l			#0,(a0)+
	move.l			#0,(a1)+
	move.l			#0,(a0)+
	move.l			#0,(a1)+
	move.l			#0,(a0)+
	move.l			#0,(a1)+
	lea			4(a0),a0
	lea			4(a1),a1
	lea			10(a2),a2
	lea			10(a3),a3
	dbra.b			d0,\startcopyscr2

	bra			\nofg

\loop

	move.w		position_scrolling1,d0
	move.w		scroll_mode,d1
	tst.b			d1
	beq			\no_test_fcttimer1
	move.b		kill_all,d1
	tst.b			d1
	bne			\jump_scroll1
\no_test_fcttimer1
	add			#1,d0
	move.w		d0,position_scrolling1
\jump_scroll1
	move.w		timer_scrollreset1,d1
	cmp.w			d0,d1
	bne			\no_scroll_reset1
	move.w		#0,position_scrolling1
	move.l			memorize_scroling,a5
	move.l			8(a5),d0
	move.l			save_level_add,d1
	add.l			d1,d0
	move.l			d0,background_addr
\no_scroll_reset1

	lea			scroll_vars(PC),a4			; Background

	move.w		(a4)+,d0				; Background_offset
	move.l			(a4)+,a2				; Background_addr
	move.l			(a4)+,a3				; Background_tiles
	bsr			ShowBackground

	tst.w			4+14(a4)				; ForeGround enabled
	beq			\nofg

	move.l			scrolling,d0
	cmp.b			#1,d0
	beq			\nofg
	move.w		position_scrolling2,d0
	move.w		position_scrolling3,d2
	add			#1,d0
	move.w		d0,position_scrolling2
	add			#1,d2
	move.w		d2,position_scrolling3
\jump_scroll2
	move.w		timer_scrollreset2,d1
	cmp.w			d0,d1
	bne			\no_scroll_reset2
	move.w		#0,position_scrolling2
	move.l			memorize_scroling,a5
	move.l			12(a5),d0
	move.l			save_level_add,d1
	add.l			d1,d0
	move.l			d0,foreground_addr

\no_scroll_reset2

	move.w		timer_scrollreset3,d1
	cmp.w			d2,d1
	bne			\no_scroll_reset3
	move.w		#0,position_scrolling3
	move.l			memorize_scroling,a5
	move.l			16(a5),d0
	move.l			save_level_add,d1
	add.l			d1,d0
	move.l			d0,sforeground_addr

\no_scroll_reset3

	addq.l			#4,a4					; Foreground
	move.w		(a4)+,d0				; Foreground_offset
	move.l			(a4)+,a2				; Foreground_addr
	move.l			(a4)+,a3				; Foreground_tiles
	bsr			ShowForeground

	addq.l			#6,a4					; sForeground
	move.w		(a4)+,d0				; sForeground_offset
	move.l			(a4)+,a2				; sForeground_addr
	move.l			(a4)+,a3				; sForeground_tiles
	bsr			sShowForeground

\nofg
	move.w		scroll_mode,d0
	tst.b			d0
	beq			\add_view
	move.b		kill_all,d0
	tst.b			d0
	bne			\cls_scr
\add_view
	bsr			MakeScroll
\cls_scr

	ENDM

; *******************************************
; Copie cran virtuel vers true_screen
; *******************************************
;
; Copie un cran virtuel vers un cran physique, 4 niveaux de gris

copy_vmem_to_tscr		MACRO
	move.l		save_add1,a0
	move.l		save_add2,a1
	move.l		plane0,a2
	move.l		plane1,a3
	lea		2(a0),a0
	lea		2(a1),a1
	IFND ti89
	lea		10(a2),a2
	lea		10(a3),a3
	move.w	#127,d0
	ENDIF
	IFD ti89
	move.l		yship,d1
	cmp.b		#32,d1
	bls		\no_change
	cmp.b		#143,d1
	bls		\no_change_to_max
	add		#34*24,a0
	add		#34*24,a1
	bra		\no_change
\no_change_to_max
	sub		#32,d1
	move.w	d1,d2
	lsr.w		#2,d1
	lsr.w		#4,d2
	add		d2,d1
	move.w	d1,d0
	lsl.w		#4,d1
	lsl.w		#3,d0
	add		d0,d1
	add		d1,a0
	add		d1,a1
\no_change
	move.w	#93,d0
	ENDIF
\startcopyscr
	move.l		(a0)+,(a2)+
	move.l		(a1)+,(a3)+
	move.l		(a0)+,(a2)+
	move.l		(a1)+,(a3)+
	move.l		(a0)+,(a2)+
	move.l		(a1)+,(a3)+
	move.l		(a0)+,(a2)+
	move.l		(a1)+,(a3)+
	move.l		(a0)+,(a2)+
	move.l		(a1)+,(a3)+
	lea		4(a0),a0
	lea		4(a1),a1
	lea		10(a2),a2
	lea		10(a3),a3
	dbra.b		d0,\startcopyscr
	ENDM