; ***************************
; ** Datas permanentes **
; ***************************

; SolarStriker
; *************

	IFND ti89
board:
	include		"board.gfx"
	ENDIF

vies_i:
	IFND ti89
	incbin		"vies.bin"
	ENDIF
	IFD ti89
	incbin		"minivies.bin"
	ENDIF

crash:
	incbin		"crash0.bin"
	incbin		"crash1.bin"
gameover:
	incbin		"gameover.bin"

pause:
	include		"pause.gfx"

	IFND ti92
plane0		EQU	graphlib::plane1
plane1		EQU	graphlib::plane0
gray_on	EQU	graphlib::gray4
gray_off	EQU	graphlib::gray2
	ENDIF

	IFD ti92
plane0		EQU	gray4lib::plane0
plane1		EQU	gray4lib::plane1
gray_on	EQU	gray4lib::on
gray_off	EQU	gray4lib::off
	ENDIF

; Coordonnes du vaisseau

xship		dc.l	0
yship		dc.l	0

; Gestion mmoire virtuelle

save_handle	dc.w	0
save_add1	dc.l	0
save_add2	dc.l	0

; Coordonnes des 3 tirs

xfire		ds.w	3
yfire		ds.w	3

; Gestion de l'ordre de bonification des tirs

tirs_ordre	dc.b	0,1,1,2,2,3
damage_ordre	dc.b	1,2,2,3,3,5

; Indicateurs de synchronisation des tirs

fire_sync		dc.b	0
fire_snk		dc.b	0

; Type de tirs

fire_type		dc.b	0
damage		dc.b	0
type_explode		dc.b	0

; Variable globale

scroll_mode		dc.w	0
save_level_add	dc.l	0
no_put_ship_ok	dc.w	0
recall_sprite		dc.b	0
vies			dc.b	0
startship		dc.w	0
position_table_niv	dc.w	0
position_niveau	dc.w	0
position_scrolling1	dc.w	0
position_scrolling2	dc.w	0
position_scrolling3	dc.w	0
perduint		dc.w	0
ecart_x		dc.b	0
ecart_y		dc.b	0
niveau_run		dc.l	0
continue_game	dc.w	0

key		dc.b	0
old_key	dc.b	0
kill_all		dc.b	0
EVEN	
score_hex	dc.l	0
mscore_hex	dc.l	0
score		ds.b	8
max_score	dcb.b	8,48
Taille_ecran	dc.w	0

misc_info:			; LIMITE = 1 item
	dc.b	0,0		; Position X, Position Y
	dc.w	0		; Animation en cours (sur 2 anims)

ennemy_info:			; LIMITE = 15 ennemis simultans
	dc.w	0		; Timer
	dc.b	0,0,0		; Numro de la trajectoire, Numro du sprite, Numro du tir
	dc.b	0,0		; Type de mouvements, Position X
	dc.b	0,0		; Tot. animation, Act. animation
	dc.b	0,0,0		; Protection, Item, Buffer pour mouvements spciaux
	ds.l	3
	ds.l	3
	ds.l	3
	ds.l	3
	ds.l	3
	ds.l	3
	ds.l	3
	ds.l	3
	ds.l	3
	ds.l	3
	ds.l	3
	ds.l	3
	ds.l	3
	ds.l	3

tirs_info:			; LIMITE = 20 tirs simultans (seulement ?)
	dc.b	0,0,0,0,0	; Juste pour viter des critiques, je sais
	dc.b	0,0,0,0,0	; que l'on peut mettre ds.b, mais c'est
	dc.b	0,0,0,0,0	; moins clair dans le code
	dc.b	0,0,0,0,0
	dc.b	0,0,0,0,0	; Type de tirs, pos_X, pos_Y, direction
	dc.b	0,0,0,0,0
	dc.b	0,0,0,0,0	; Direction 1 :
	dc.b	0,0,0,0,0	; Gauche = 0, Neutre = 1, Droite = 2
	dc.b	0,0,0,0,0
	dc.b	0,0,0,0,0	; Direction 2 :
	dc.b	0,0,0,0,0	; Haut = 0, Neutre = 1, Bas = 2
	dc.b	0,0,0,0,0
	dc.b	0,0,0,0,0	; Type de tirs :
	dc.b	0,0,0,0,0	; Bazooka simple = 1
	dc.b	0,0,0,0,0	; Balle triple = 2
	dc.b	0,0,0,0,0	; Balle directive = 3
	dc.b	0,0,0,0,0
	dc.b	0,0,0,0,0
	dc.b	0,0,0,0,0
	dc.b	0,0,0,0,0

explod_coord:			; LIMITE = 15 explosions simultanes
	dc.b	0,0,0,0		; Type d'explosion :
	dc.b	0,0,0,0		; Rflexion (32*32) = 1
	dc.b	0,0,0,0		; Destruction (32*32) = 2
	dc.b	0,0,0,0		; Coordonnes X,Y,animation
	dc.b	0,0,0,0
	dc.b	0,0,0,0
	dc.b	0,0,0,0
	dc.b	0,0,0,0
	dc.b	0,0,0,0
	dc.b	0,0,0,0
	dc.b	0,0,0,0
	dc.b	0,0,0,0
	dc.b	0,0,0,0
	dc.b	0,0,0,0
	dc.b	0,0,0,0

;******************** Program Variables ***********************

current_level		dc.l	0
rec_niveau		dc.l	0
save_add11		dc.l	0
save_add21		dc.l	0
scroll_pos		dc.b	0
rand_seed		dc.w	0
save_handlem	dc.w	0
memorize_scroling	dc.l	0
timer_scrollreset1	dc.w	0
timer_scrollreset2	dc.w	0
timer_scrollreset3	dc.w	0
scrolling		dc.l	2
position		dc.w	0
main_curseur		dc.l	0
second_curseur	dc.l	0
quit			dc.w	0
jeu_gagne		dc.w	0

	IFND ti89
titre:
	incbin	"titre.bin"
	ENDIF

	IFD ti89
texte_score	dc.b	"Score",0
	ENDIF

; Format des structures de texte
; ------------------------------

; Struct:
;	dc.b	X,Y,Font,"String0",0
;	dc.b	X,Y,Font,"String1",0
;	dc.b	X,Y,Font,"String2",0
;	dc.b	0

; X    : Nombre entre 1 et 239, pas de test de sortie cran !
; Y    : Nombre entre 0 et 127, pas de test de sortie cran !
; Font : 0 = Large, 1 = Moyenne, 2 = Petite

menu_1:
	dc.b	88,45,0,"NEW GAME",0
	dc.b	88,58,0,"CONTINUE",0
	dc.b	80,71,0,"HIGH-SCORE",0
	dc.b	92,84,0,"OPTIONS",0
	dc.b	100,97,0,"ABOUT",0
	dc.b	104,110,0,"EXIT",0
	dc.b	0
menu_2:
	dc.b	56,45,0,"SCROLL",0
	dc.b	48,97,0,"CONTRAST",0
	dc.b	64,110,0,"EXIT",0
	dc.b	0
menu_3:
	dc.b	72,45,0,"SolarStriker",0
	dc.b	72,57,0,"Version 1.00",0
	dc.b	70,77,1,"Brian TRIBONDEAU",0
	dc.b	110,87,1,"and",0
	dc.b	73,97,1,"Benoit SCHERRER",0
	dc.b	46,108,2,"W E B : http://w w w.ti-fr.org/t3",0
	dc.b	63,115,2,"M A IL : brian.t @ free.fr",0
	dc.b	0
menu_4:
	dc.b	80,45,0,"High-Score",0
	dc.b	70,65,1,"The best shooter",0
	dc.b	74,75,1,"of all-time has",0
	dc.b	0
high_score:
	dc.b	90,90,0
	ds.b	8
	dc.b	100,105,1,"points",0
	dc.b	0
new_hiscore:
	dc.b	"You set a new High-Score",0
congrat:
	dc.b	"CONGRATULATION",0

anim_scroll		dc.w	20
scroll_def:
	incbin	"scroll1.bin"
	incbin	"scroll2.bin"
	incbin	"scroll3.bin"
	incbin	"scroll4.bin"
	incbin	"scroll5.bin"
	incbin	"scroll6.bin"
scroll_option:
	incbin	"ascrol11.bin"
	incbin	"ascrol12.bin"
	incbin	"ascrol21.bin"
	incbin	"ascrol22.bin"
	incbin	"ascrol31.bin"
	incbin	"ascrol32.bin"
contraste:
	incbin	"contrast.bin"