; ********************************
; Dmarrage des tirs ennemis *
; ********************************

; Entre :		D0 = Position X de l'ennemi
;		D1 = Position Y de l'ennemi
;		A3 = Table des ennemis positionne

start_ennemy_fire		MACRO

	movem.l		d0-d7/a0-a5,-(a7)
	move.b		5(a3),d2
	cmp.b			#1,d2
	bne			\No_more_verif
	move.b		11(a3),d2
	tst.b			d2
	bne			\NO_PLACE
\No_more_verif
	move.w		(a3),d2			; D2 = Timer propre de l'ennemi
	clr.w		d3
	move.b		4(a3),d3
	lsl.w		#2,d3
	lea		tir_table,a4
	add		d3,a4
	move.l		(a4),a4			; A4 = Position des infos sur les tirs  effectuer
\LOOP
	move.w		(a4),d4			; D4 = Timer de dmarrage du missile
	tst.w		d4
	beq		\NO_PLACE
	cmp.w		d2,d4			; Comparaison de timers
	beq		\NO_LOOP
	add		#6,a4
	bra		\LOOP
\NO_LOOP

	lea		tirs_info,a5		; Tables d'infos sur les tirs en cours
	move.w		#19,d5
\PLACE

	move.b		(a5),d6			; Vrification sur la prsence d'un tir
	tst.b		d6
	beq		\OK_PLACE		; Non, y'a personne ici...
	add		#5,a5
	dbra.b		d5,\PLACE	
	bra		\NO_PLACE		; Pas de chance, tout est occup !
\OK_PLACE
	move.w		2(a4),d6
	move.b		d6,(a5)			; On charge le type de tirs
	move.b		4(a4),d4
	add		d0,d4
	move.b		d4,1(a5)			; Position x
	move.b		5(a4),d3
	add		d1,d3
	move.b		d3,2(a5)			; Position y

	cmp.b		#1,d6
	beq		\NO_PLACE
	cmp.b		#3,d6
	beq		\TIR_AUTO

	move.b		#0,3(a5)			; Vers la gauche
	move.b		#2,4(a5)			; Vers le bas
	
	lea		tirs_info,a5		; Tables d'infos sur les tirs en cours
	move.w		#19,d5
\PLACE_TIR1
	move.b		(a5),d6			; Vrification sur la prsence d'un tir
	tst.b		d6
	beq		\PLACE_TIR2
	lea		5(a5),a5
	dbra.b		d5,\PLACE_TIR1
	bra		\NO_PLACE

\PLACE_TIR2
	move.w		2(a4),d6
	move.b		d6,(a5)			; On charge le type de tirs
	move.b		4(a4),d4
	add		d0,d4
	move.b		d4,1(a5)			; Position x
	move.b		5(a4),d4
	add		d1,d4
	move.b		d4,2(a5)			; Position y
	move.b		#1,3(a5)			; Vers le centre
	move.b		#2,4(a5)			; Vers le bas

	lea		tirs_info,a5		; Tables d'infos sur les tirs en cours
	move.w		#19,d5
\PLACE_TIR3
	move.b		(a5),d6			; Vrification sur la prsence d'un tir
	tst.b		d6
	beq		\PLACE_TIR4
	lea		5(a5),a5
	dbra		d5,\PLACE_TIR3
	bra		\NO_PLACE
\PLACE_TIR4
	move.w		2(a4),d6
	move.b		d6,(a5)			; On charge le type de tirs
	move.b		4(a4),d4
	add		d0,d4
	move.b		d4,1(a5)			; Position x
	move.b		5(a4),d4
	add		d1,d4
	move.b		d4,2(a5)			; Position y
	move.b		#2,3(a5)			; Vers la droite
	move.b		#2,4(a5)			; Vers le bas
	bra		\NO_PLACE

\TIR_AUTO

	move.l		xship,d0
	cmp.b		d0,d4			; Compare Xship avec posX
	bhi		\tir_vers_droite
; \tir_vers_gauche
	sub		d4,d0
	move.b		d0,ecart_x
	move.b		#2,3(a5)
	bra		\test_suite
\tir_vers_droite
	sub		d0,d4
	move.b		d4,ecart_x
	move.b		#0,3(a5)

\test_suite

	move.l		yship,d1
	cmp.b		d1,d3			; Compare Yship avec posY
	bhi		\tir_vers_bas
; \tir_vers_haut
	sub		d3,d1
	move.b		d1,ecart_y
	move.b		#2,4(a5)
	bra		\test_fin
\tir_vers_bas
	sub		d1,d3
	move.b		d3,ecart_y
	move.b		#0,4(a5)

\test_fin

	clr.w		d0
	move.b		ecart_x,d0
	tst.b		d0
	bne		\no_horizontal
	move.b		#1,3(a5)
	bra		\NO_PLACE
\no_horizontal
	clr.w		d1
	move.b		ecart_y,d1
	tst.b		d1
	bne		\no_vertical
	move.b		#1,4(a5)
	bra		\NO_PLACE
\no_vertical

	lsl.w		#5,d0	
	divu.w		d1,d0			; Equation trigo simple
	cmp.w		#77,d0
	bls		\No_milieu_pour_Y
; No_milieu_pour_Y
	move.b		#1,4(a5)
	bra		\NO_PLACE
\No_milieu_pour_Y
	cmp.w		#13,d0
	bhi		\NO_PLACE
; No_milieu_pour_X
	move.b		#1,3(a5)
	bra		\NO_PLACE

\NO_PLACE
	movem.l		(a7)+,d0-d7/a0-a5
	ENDM

; **************************
; Suivi des tirs ennemis *
; **************************

put_ennemy_fire		MACRO
	lea		tirs_info,a3
	move.w		#19,d7
boucle_put:
	move.b		(a3),d2
	tst.b		d2
	beq		no_boucle_put	
	move.b		1(a3),d0
	move.b		2(a3),d1
	move.l		xship,d2
	move.l		yship,d3

	move.b		d0,d4
	sub		#10,d0		; D0 = X0 - 6
	add		#4,d4		; D4 = X0 + 22

	move.b		d1,d5
	sub		#4,d1
	add		#4,d5

	cmp.b		d2,d0
	bls		cond1oke
	bra		nocollisione
cond1oke:
	cmp.b		d2,d4
	bhi		cond2oke
	bra		nocollisione
cond2oke:
	cmp.b		d3,d1
	bls		cond3oke
	bra		nocollisione
cond3oke:
	cmp.b		d3,d5
	bhi		collisione
	bra		nocollisione
collisione:
	move.w		#1,perduint
nocollisione:

	clr.l		d0
	clr.l		d1
	move.b		1(a3),d0
	move.b		2(a3),d1
	cmp.b		#156,d1
	bhi		erase_bullet
	cmp.b		#27,d1
	bls		erase_bullet
	cmp.b		#173,d0
	bhi		erase_bullet
	cmp.b		#3,d0
	bls		erase_bullet

	move.b		(a3),d2

	cmp.b		#1,d2
	bne		no_directtir

	add		#3,d1
	move.b		d1,2(a3)
	lea		ennemy_fire_missile,a0
	move.l		save_add1,a1
	move.l		save_add2,a2
	jsr		putsprite_fast
	bra		no_boucle_put
no_directtir:

	move.b		3(a3),d2
	move.b		4(a3),d3
	lsl.b		#1,d2
	lsl.b		#1,d3
	subq.b		#2,d2
	subq.b		#2,d3
	add.b		d2,d0
	add.b		d3,d1
	move.b		d0,1(a3)
	move.b		d1,2(a3)
	lea		ennemy_fire_balle,a0
	move.l		save_add1,a1
	move.l		save_add2,a2
	jsr		putsprite_fast
	bra		no_boucle_put

erase_bullet:
	move.b		#0,(a3)
no_boucle_put:
	add		#5,a3
	dbra.b		d7,boucle_put
	ENDM