;******************
; Gestion des tirs
;******************

move_fire			MACRO

	read_key
	test_fire

	bra		fire_end


; Initialisation ventuelle des tirs
; **********************************

fire_ok:

	move.b	fire_snk,d0
	tst.b		d0
	bne		fire_end		; Synchro activ

; Test tir 1 affich

init_fire_one:

	lea		yfire,a0
	move.w	(a0),d0
	tst.w		d0
	bhi		init_fire_two

	move.b	#1,fire_snk
	move.b	#0,fire_sync
	lea		xfire,a0
	lea		yfire,a1
	move.l		xship,d0
	move.l		yship,d1
	add		#12,d1
	move.w	d0,(a0)
	move.w	d1,(a1)
	bra		fire_end

init_fire_two:

	lea		yfire,a0
	add		#2,a0
	move.w	(a0),d0
	tst.w		d0
	bhi		init_fire_thr

	move.b	#1,fire_snk
	move.b	#0,fire_sync
	lea		xfire,a0
	lea		yfire,a1
	move.l		xship,d0
	move.l		yship,d1
	add		#12,d1
	add		#2,a0
	add		#2,a1
	sub		#2,d1
	move.w	d0,(a0)
	move.w	d1,(a1)
	bra		fire_end

init_fire_thr:

	lea		yfire,a0
	add		#4,a0
	move.w	(a0),d0
	tst.w		d0
	bne		fire_end

	move.b	#1,fire_snk
	move.b	#0,fire_sync
	lea		xfire,a0
	lea		yfire,a1
	move.l		xship,d0
	move.l		yship,d1
	add		#12,d1
	add		#4,a0
	add		#4,a1
	sub		#4,d1
	move.w	d0,(a0)
	move.w	d1,(a1)
	bra		fire_end

fire_end:

; Vrification & update des coordonnes
; *****************************************

; Dclenchement de la synchro

	move.b	fire_sync,d0
	add.b		#1,d0
	cmp.b		#5,d0
	beq		reset_fire_sync
	bra		fire_sync_inc

reset_fire_sync:
	move.b	#0,d0
	move.b	d0,fire_snk
fire_sync_inc:
	move.b	d0,fire_sync

test_fire_one:

	lea		yfire,a0

	move.w	(a0),d0
	cmp.w		#0,d0
	beq		test_fire_two
	cmp.w		#15,d0
	bls		fire_one_out
	sub.w		#12,d0
	move.w	d0,(a0)
	bra		test_fire_two
fire_one_out:
	move.w	#0,(a0)

test_fire_two:
	add		#2,a0
	move.w	(a0),d0
	cmp.w		#0,d0
	beq		test_fire_three
	cmp.w		#15,d0
	bls		fire_two_out
	sub.w		#12,d0
	move.w	d0,(a0)
	bra		test_fire_three
fire_two_out:
	move.w	#0,(a0)

test_fire_three:
	add		#2,a0
	move.w	(a0),d0
	cmp.w		#0,d0
	beq		fire_stop
	cmp.w		#15,d0
	bls		fire_three_out
	sub.w		#12,d0
	move.w	d0,(a0)
	bra		fire_stop
fire_three_out:
	move.w	#0,(a0)

fire_stop:

	ENDM
