;*****************************************************
; Affichage direct : Sprite 16,32 4 gray with mask
;*****************************************************

; Ncessite	D0 = X ( 0-191 )			OK
;		D1 = Y ( 0-191 )			OK
;		A0 = Adresse du sprite		OK

putsprite:					; Routine de sprite normale

; SAUVEGARDE DES REGISTRES
	movem.l	d2-d7/a3-a6,-(a7)	; Sauvegarde des variables
	move.l		save_add1,a1
	move.l		save_add2,a2
	move.w	d1,d4
	clr.l		d2
	move.b	d0,d2			; Division + reste
	and.b		#7,d2			; D2 = Dcalage du sprite en BITS
	lsr.b		#3,d0			; D0 = Position X
	clr.l		d3
	move.b	d1,d3			; Multiplication de D1 * 24 , EQU :
	lsl.w		#3,d1			; D1 * ( 8 + 16 ) = D1 * 8 + D1,D3 * 16
	lsl.w		#4,d3			; D1 * 8 + D3 * 16 = D1 * 24
	add		d1,d3			; D3 = Position Y
	add		d0,d3			; D3 = Position Y + X
	add		d3,a1			; Calcul de l'adresse A1
	sub		#$300,a1
	add		d3,a2			; Calcul de l'adresse A2
	sub		#$300,a2

; DEBUT - Routines de redimensionnement

	move.l		a0,a4
	cmp.w		#31,d4
	bls		reduce_y_byup
	bra		test_enddown
reduce_y_byup:
	move.w	#32,d6
	sub		d4,d6
	move.w	(a0),d5
	tst.b		d5
	beq		add_by16
; add_by32
	lea		6(a0),a0
	move.w	d6,d7
	mulu		#24,d7
	add.w		d7,a1
	add.w		d7,a2
	move.w	d6,d5
	lsl		#2,d5
	add		d5,a0
	move.b	#1,d7
	bra		end_reducing
add_by16:
	lea		6(a0),a0
	move.w	d6,d7
	mulu		#24,d7
	add.w		d7,a1
	add.w		d7,a2
	move.w	d6,d5
	lsl		#1,d5
	add		d5,a0
	move.b	#1,d7
	bra		end_reducing
test_enddown:
	move.b	#0,d7
suite_test:
	move.w	2(a4),d5
	add		d4,d5
	cmp.w		#159,d5
	bhi		reduce_y_bydown
	bra		test_endup
reduce_y_bydown:
	sub		#160,d5
	move.w	d5,-(a7)
	move.w	(a4),d6
	move.b	#2,d7
	bra		end_reducing
test_endup:
	move.b	#0,d7
end_reducing:

	; FIN - Routines de redimensionnement

	move.l		a1,d3			; Anti adress error protection
	and.l		#1,d3
	tst.b		d3
	beq		nombre_ok
	sub		#1,a1
	sub		#1,a2
	move.b	#0,d3
	bra		modif_nombre
nombre_ok:
	move.b	#1,d3
modif_nombre:
	clr.l		d5
	move.w	(a4)+,d1		; D1 = Taille du sprite en largeur (octets)
	move.w	(a4)+,d4		; D4 = Taille du sprite en hauteur (bits)
	move.w	(a4)+,d5		; D5 = Evite la multiplication
	tst.b		d7
	beq		continue_s1
	sub		d6,d4
	bra		continue_s2
continue_s1:
	lea		6(a0),a0
continue_s2:
	cmp.b		#2,d7
	bne		suite_puts
	move.w	(a7)+,d7
	tst.b		d6
	beq		trans
trans:
	sub		d7,d4
	lea		6(a0),a0
	tst.b		d1
	bne		nosub_for_boucle
	sub		#1,d4
nosub_for_boucle:

suite_puts:
	move.l		a0,a3
	add		d5,a3			; A3 = Adresse du sprite NOIR + GRIS fonc
	move.l		a3,a4
	add		d5,a4			; A4 = Adresse du sprite NOIR + GRIS clair
BY:

	; COMPARAISON POUR CHOIX 16, 32 BITS

	tst.b		d1
	beq		put_16bsegment
put_32bsegment:
	move.w	d1,-(a7)
	move.w	d4,-(a7)
	clr.l		d0
	clr.l		d4
	clr.l		d6
	clr.l		d7
	move.w	(a0)+,d5
	swap		d5
	clr.w		d5
	lsr.l		d2,d5
	move.w	(a0)+,d0
	swap		d0
	clr.w		d0
	lsr.l		d2,d0
	move.w	(a3)+,d6
	swap		d6
	lsr.l		d2,d6
	move.w	(a3)+,d4
	swap		d4
	clr.w		d4
	lsr.l		d2,d4
	move.w	(a4)+,d7
	swap		d7
	lsr.l		d2,d7
	move.w	(a4)+,d1
	swap		d1
	clr.w		d1
	lsr.l		d2,d1
	tst.b		d3
	beq		add_rotation32
	bra		suite_code32
add_rotation32:
	lsr.l		#8,d0
	lsr.l		#8,d1
	lsr.l		#8,d4
	lsr.l		#8,d5
	lsr.l		#8,d6
	lsr.l		#8,d7
suite_code32:
	not.l		d5
	and.l		d5,(a1)
	and.l		d5,(a2)
	or.l		d6,(a1)
	or.l		d7,(a2)
	lea		2(a1),a1
	lea		2(a2),a2
	not.l		d0
	and.l		d0,(a1)
	and.l		d0,(a2)
	or.l		d4,(a1)
	or.l		d1,(a2)
	lea		22(a1),a1
	lea		22(a2),a2
	move.w	(a7)+,d4
	move.w	(a7)+,d1
	dbra.b		d4,BY
	bra		END_X
put_16bsegment:
	clr.l		d6
	clr.l		d7
	move.w	(a0)+,d5
	swap		d5
	clr.w		d5
	lsr.l		d2,d5
	move.w	(a3)+,d6
	swap		d6
	lsr.l		d2,d6
	move.w	(a4)+,d7
	swap		d7
	lsr.l		d2,d7
	tst.b		d3
	beq		add_rotation16
	bra		suite_code16
add_rotation16:
	lsr.l		#8,d5
	lsr.l		#8,d6
	lsr.l		#8,d7
suite_code16:
	not.l		d5
	and.l		d5,(a1)
	and.l		d5,(a2)
	or.l		d6,(a1)
	or.l		d7,(a2)
	lea		24(a1),a1
	lea		24(a2),a2
	dbra.b		d4,BY
END_X:
	movem.l	(a7)+,d2-d7/a3-a6	; Sauvegarde des variables
	rts

;*****************************************************
; Affichage direct : Sprite 8,16 no gray without mask
;*****************************************************

; Ncessite	D0 = X ( 0-191 )			OK
;		D1 = Y ( 0-191 )			OK
;		A0 = Adresse du sprite		OK
;		A1 = Gray_plane1			OK
;		A2 = Gray_plane2			OK

putsprite_fast:					; Routine de sprite rapide

; SAUVEGARDE DES REGISTRES

	movem.l	d2-d7/a3-a6,-(a7)	; Sauvegarde des variables
	move.w	d1,d4
	clr.l		d2
	move.b	d0,d2			; Division + reste
	and.b		#7,d2			; D2 = Dcalage du sprite en BITS
	lsr.b		#3,d0			; D0 = Position X
	clr.l		d3
	move.b	d1,d3			; Multiplication de D1 * 24 , EQU :
	lsl.w		#3,d1			; D1 * ( 8 + 16 ) = D1 * 8 + D1,D3 * 16
	lsl.w		#4,d3			; D1 * 8 + D3 * 16 = D1 * 24
	add		d1,d3			; D3 = Position Y
	add		d0,d3			; D3 = Position Y + X
	add		d3,a1			; Calcul de l'adresse A1
	sub		#$300,a1
	add		d3,a2			; Calcul de l'adresse A2
	sub		#$300,a2

	; DEBUT - Routines de redimensionnement

	move.l		a0,a4
	cmp.w		#31,d4
	bls		reduce_y_byup_fast
	bra		test_enddown_fast
reduce_y_byup_fast:
	move.w	#32,d6
	sub		d4,d6
	move.w	(a0),d5
	tst.b		d5
	beq		add_by8_fast
; add_by16_fast
	lea		6(a0),a0
	move.w	d6,d7
	mulu		#24,d7
	add.w		d7,a1
	add.w		d7,a2
	move.w	d6,d5
	lsl		#1,d5
	add		d5,a0
	move.b	#1,d7
	bra		end_reducing_fast
add_by8_fast:
	lea		6(a0),a0
	move.w	d6,d7
	mulu		#24,d7
	add.w		d7,a1
	add.w		d7,a2
	move.w	d6,d5
	add		d5,a0
	move.b	#1,d7
	bra		end_reducing_fast
test_enddown_fast:
	move.b	#0,d7
suite_test_fast:
	move.w	2(a4),d5
	add		d4,d5
	cmp.w		#159,d5
	bhi		reduce_y_bydown_fast
	bra		test_endup_fast
reduce_y_bydown_fast:
	sub		#160,d5
	move.w	d5,-(a7)
	move.w	(a4),d6
	move.b	#2,d7
	bra		end_reducing_fast
test_endup_fast:
	move.b	#0,d7
end_reducing_fast:

	; FIN - Routines de redimensionnement

	move.l		a1,d3			; Anti adress error protection
	and.l		#1,d3
	tst.b		d3
	beq		nombre_ok_fast
	sub		#1,a1
	sub		#1,a2
	move.b	#0,d3
	bra		modif_nombre_fast
nombre_ok_fast:
	move.b	#1,d3
modif_nombre_fast:
	clr.l		d5
	move.w	(a4)+,d1		; D1 = Taille du sprite en largeur (octets)
	move.w	(a4)+,d4		; D4 = Taille du sprite en hauteur (bits)
	move.w	(a4)+,d5		; D5 = Evite la multiplication
	tst.b		d7
	beq		continue_s1_fast
	sub		d6,d4
	bra		continue_s2_fast
continue_s1_fast:
	lea		6(a0),a0
continue_s2_fast:
	cmp.b		#2,d7
	bne		BY_fast
	move.w	(a7)+,d7
	tst.b		d6
	beq		trans_fast
trans_fast:
	sub		d7,d4
	lea		6(a0),a0
	tst.b		d1
	bne		nosub_for_boucle_fast
	sub		#1,d4
nosub_for_boucle_fast:
BY_fast:

	; COMPARAISON POUR CHOIX 8, 16 BITS

	tst.b		d1
	beq		put_8bsegment_fast
	clr.l		d5
	move.w	(a0)+,d5
	swap		d5
	clr.w		d5
	lsr.l		d2,d5
	tst.b		d3
	beq		add_rotation16_fast
	bra		suite_code16_fast
add_rotation16_fast:
	lsr.l		#8,d5
suite_code16_fast:
	or.l		d5,(a1)
	or.l		d5,(a2)
	lea		24(a1),a1
	lea		24(a2),a2
	dbra.b		d4,BY_fast
	bra		END_X_fast
put_8bsegment_fast:
	clr.l		d5
	move.b	(a0)+,d5
	swap		d5
	lsl.l		#8,d5
	clr.w		d5
	lsr.l		d2,d5
	tst.b		d3
	beq		add_rotation16_fast
	bra		suite_code16_fast
add_rotation8_fast:
	lsr.l		#8,d5
suite_code8_fast:
	and.l		d5,(a1)
	and.l		d5,(a2)
	lea		24(a1),a1
	lea		24(a2),a2
	dbra.b		d4,BY_fast
END_X_fast:
	movem.l	(a7)+,d2-d7/a3-a6	; Sauvegarde des variables
	rts